/***************************************************************************
 *   Copyright (C) 2007 by Johannes Schaub                                 *
 *   schaub-johannes@web.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef REGISTEREVENT_H
#define REGISTEREVENT_H

#include <qevent.h>
#include <list>

class Source;
class SourcesScanner;

/**
 * @author Johannes Schaub <schaub-johannes@web.de>
 */
class RegisterEvent : public QCustomEvent{
public:
    RegisterEvent(SourcesScanner* scanner, const std::list<Source*>& sources);
    ~RegisterEvent();
    static const int TYPE = QEvent::User + 2;
    
    /// the sources which were found by the scanner
    const std::list<Source*> & getSources() const;
    
    /// the scanner which originated this event
    SourcesScanner* getScanner();
private:
    SourcesScanner* mScanner;
    std::list<Source*> mSources;
};

#endif
