/***************************************************************************
 *   Copyright (C) 2007 by Johannes Schaub                                 *
 *   schaub-johannes@web.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "sourcesscanner.h"
#include "registerevent.h"
#include <qapplication.h>
#include <list>
#include "../kima.h"

SourcesScanner::SourcesScanner(Kima* applet, std::list<Source*> (*scanFunc)(QWidget*))
 : QThread(), mApplet(applet), mScanFunc(scanFunc)
{
}

SourcesScanner::~SourcesScanner()
{
}

void SourcesScanner::run()
{
    // find sources
    std::list<Source*> sources = mScanFunc(mApplet);
    
    // and send those sources to Kima, so that they can be
    // registered.
    RegisterEvent * evt = new RegisterEvent(this, sources);
    QApplication::postEvent(mApplet, evt);
}
