/***************************************************************************
 *   Copyright (C) 2007 by Johannes Schaub                                 *
 *   schaub-johannes@web.de                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SOURCESSCANNER_H
#define SOURCESSCANNER_H

#include <qthread.h>
#include <list>

class Kima;
class QWidget;
class Source;

/**
	@author Ken Werner <ken.werner@web.de>
*/
class SourcesScanner : public QThread
{
public:
    /**
     * takes the applet and the scan function which will
     * actually search for Sources. we will send a event 
     * to the applet if we found our Sources.
     */
    SourcesScanner(Kima* applet, std::list<Source*> (*scanFunc)(QWidget*));
    ~SourcesScanner();
    
    /**
     * calls the source-scanner mScanFunc, which will return
     * list of Sources pointers. send these pointers to the
     * applet using a custom event (RegisterEvent).
     */
    virtual void run();
private:
    Kima* mApplet;
    
    /// the scan function to be used by this scanner.
    std::list<Source*> (*mScanFunc)(QWidget*);
};

#endif
